#include <LPC213X.h>
#include <RTL.h>
#include <stdio.h>

#include "delay.h"
#include "lcd.h"

OS_TID tsk1, tsk2;

__task void task_init(void);
__task void task1(void);
__task void task2(void);
__task void task_lcd(void);

int x1 = 200, y1 = 50, x2 = 230, y2 = 310;
int x_1 = -3, y_1 = 3;
int x_2 = -3, y_2 = -3;

int main()
{
	PINSEL0 = 0x00000000;
	IO0DIR =  0x00C00000;
	PINSEL1 = 0x00080000;
	PINSEL2 = 0x00000000;
	IO1DIR =  0x00000000;

	os_sys_init(task_init);

	while (1)
	{
		IO0SET = 0x00C00000;
		delay_ms(1000);
		IO0CLR = 0x00C00000;
		delay_ms(1000);
	}
}

__task void task_init(void)
{
	lcd_init();
	lcd_clear();
	tsk1 = os_tsk_create(task1, 1);
	tsk2 = os_tsk_create(task2, 1);
	os_tsk_delete_self();
}

__task void task1(void)
{
	while(1)
	{
		x1 += x_1;
		if (x1 > 234 || x1 < 5)
			x_1 *= -1;

		y1 += y_1;
		if (y1 > 314 || y1 < 5)
			y_1 *= -1;

		lcd_gotoxy(0, 0);
		lcd_print("X1: ");
		lcd_print_number(x1);
		lcd_print("  Y1: ");
		lcd_print_number(y1);
		os_tsk_pass();
	}
}

__task void task2(void)
{
	while(1)
	{
		x2 += x_2;
		if (x2 > 234 || x2 < 5)
			x_2 *= -1;

		y2 += y_2;
		if (y2 > 314 || y2 < 5)
			y_2 *= -1;

		lcd_gotoxy(0, 1);
		lcd_print("X2: ");
		lcd_print_number(x2);
		lcd_print("  Y2: ");
		lcd_print_number(y2);
		os_tsk_pass();
	}
}

__task void task_lcd(void)
{
}
